/**
 * @author : Cosmin Grigore
 * @description: 
 */

#include<LiquidCrystal.h>
#include <Wire.h>

#define IRSensor1 7 // PIN 7 for Sensor IR 1
#define IRSensor2 13 // PIN 13 for Sensor IR 2
#define RedLED 8 // PIN 8 for Red Led
#define GreenLED 10 // PIN 10 for Green Led
#define buzzer 9 // PIN 9 for Buzzer

int Contrast = 60; // LCD contrast
unsigned long t1 = 0, t2 = 0; //time for  measuring 
float distance = 27.0; // distance between sensors( in cm ).
float limit = 100.0; // speed limit
float objSpeed; // Real Speed
int roundedSpeed;


LiquidCrystal lcd(12, 11, 5, 4, 3, 2);

void setup() 
{
  analogWrite(6, Contrast);
  Serial.begin(9600);
  pinMode (IRSensor1, INPUT); // sensor 1 IR pin INPUT
  pinMode(IRSensor2, INPUT); // sensor 2 IR pin INPUT
  pinMode (RedLED, OUTPUT); // Led pin OUTPUT
  pinMode (GreenLED, OUTPUT); // Led pin OUTPUT
  pinMode(buzzer, OUTPUT);
  lcd.begin(16, 2); 
}
void alert()
{ 
  digitalWrite(RedLED, HIGH);
  tone(buzzer, 1000);
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("Alert!");
  // Send char 'A' from ALERT to Bluetooth
  Serial.print("A");
}

void ok()
{
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("OK!");
  digitalWrite(GreenLED, HIGH);
  // Send char 'O' from OK to Bluetooth
  Serial.print("O");
}

void loop()
{
  // Wait for first Sensor
  while(digitalRead(IRSensor1)== 1);
  //Keep last time
  while(digitalRead(IRSensor1)== 0);
  t1=millis();

  // Keep first Time when arrive (after digitalRead = HIGH)
  while (digitalRead(IRSensor2));
  t2=millis();
  if (t1 < t2) {
    objSpeed=t2-t1;
    objSpeed=objSpeed/1000;//convert millisecond to second
    objSpeed=(distance/objSpeed);// Speed = Distance/Time
    roundedSpeed = objSpeed;
    if (objSpeed > limit) {
        alert();   
     } else { 
        ok();  
     }
     // Send rounded Speed to Bluetooth using Serial.
     Serial.print(roundedSpeed);
     lcd.setCursor(0, 1);
     lcd.print("SPEED ");
     lcd.print(roundedSpeed);
     lcd.print(" cm/s");
     delay(1000);
     digitalWrite(RedLED, LOW);
     digitalWrite(GreenLED, LOW);
     noTone(buzzer);
  } 

}
